; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	LDS temp,(adr_TASTE)
	cpi temp,0b00100000
	breq MENUE_PLUS
	cpi temp,0b00010000
	breq MENUE_CLEAR
	cpi temp,0b00110000
	breq MENUE_RESET
	rjmp MENUE_RUN
;-------------------------------------------------------------------------------
; Taste-MENUE gedrckt															
MENUE_PLUS:
	rcall BEEP_KURZ
	LDS temp,(adr_MENUE)
	inc temp
	STS(adr_MENUE),temp
	rjmp MENUE_RUN
;-------------------------------------------------------------------------------
; Taste-CLEAR gedrckt															
MENUE_CLEAR:
	rcall BEEP_KURZ
	ldi temp,(ASCII_MINUS)
	STS(adr_DIGIT3),temp
	ldi temp,(ASCII_MINUS)
	STS(adr_DIGIT2),temp
	ldi temp,(ASCII_MINUS)
	STS(adr_DIGIT1),temp
	ldi temp,(ASCII_MINUS)
	STS(adr_DIGIT0),temp
	rcall WAIT_1s
	rjmp MENUE_RUN
;-------------------------------------------------------------------------------
; beide Tasten gedrckt															
MENUE_RESET:
	BEEP_ON
	ldi temp,(0b01100011)
	STS(adr_DIGIT3),temp
	STS(adr_DIGIT2),temp
	STS(adr_DIGIT1),temp
	STS(adr_DIGIT0),temp
	rjmp MENUE_RESET
;-------------------------------------------------------------------------------
MENUE_RUN:
	ldi ZL,LOW (MENUE_SPRUNGMARKE)	; Z initialisieren	
	ldi ZH,HIGH(MENUE_SPRUNGMARKE)
	LDS temp,(adr_MENUE)
	add ZL,temp 
	adc ZH,NULL
	ijmp			; SPRUNG nach Z		
;-------------------------------------------------------------------------------
MENUE_SPRUNGMARKE:
	rjmp MENUE_P
	rjmp MENUE_U
	rjmp MENUE_ADC_U
	rjmp MENUE_i
	rjmp MENUE_ADC_i
	rjmp MENUE_BAUSTELLE
	STS(adr_MENUE),NULL	; berlauf
	rjmp MENUE_RUN
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_BAUSTELLE:
	ldi temp,(0b01001001)
	STS(adr_DIGIT3),temp
	STS(adr_DIGIT2),temp
	STS(adr_DIGIT1),temp
	STS(adr_DIGIT0),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Leistung momentan																
MENUE_P:
	LDS temp1,(adr_P_L)
	LDS temp2,(adr_P_H)
	tst temp1
	brne MENUE_P_RUN
	tst temp2
	brne MENUE_P_RUN
	STS(adr_DIGIT3),NULL
	STS(adr_DIGIT2),NULL
	STS(adr_DIGIT1),NULL
	ldi temp,(ASCII_MINUS)
	STS(adr_DIGIT0),temp
ret
;-------------------------------------------------------------------------------
MENUE_P_RUN:
	rcall ZAHL_TEMP1_2
	ldi temp,(ASCII_P)
	STS(adr_DIGIT3),temp
	STS(adr_DIGIT2),temp3
	STS(adr_DIGIT1),temp2
	STS(adr_DIGIT0),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ADC0 (U)																		
MENUE_ADC_U:
	LDS temp1,(adr_ADC_U_L)
	LDS temp2,(adr_ADC_U_H)
	rcall ZAHL_TEMP1_2
	STS(adr_DIGIT3),temp4
	STS(adr_DIGIT2),temp3
	STS(adr_DIGIT1),temp2
	STS(adr_DIGIT0),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ADC1 (i)																		
MENUE_ADC_i:
	LDS temp1,(adr_ADC_i_L)
	LDS temp2,(adr_ADC_i_H)
	rcall ZAHL_TEMP1_2
	STS(adr_DIGIT3),temp4
	STS(adr_DIGIT2),temp3
	STS(adr_DIGIT1),temp2
	STS(adr_DIGIT0),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; U 																			
MENUE_U:
	LDS temp1,(adr_U)
	rcall ZAHL_TEMP1

	ldi temp,(ASCII_V)
	STS(adr_DIGIT3),temp
	STS(adr_DIGIT2),temp3
	ori temp2,(ASCII_PUNKT)	; Punkt	
	STS(adr_DIGIT1),temp2
	STS(adr_DIGIT0),temp1
ret

; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_i:
	LDS temp1,(adr_i)
	rcall ZAHL_TEMP1

	ldi temp,(ASCII_A)
	STS(adr_DIGIT3),temp
	STS(adr_DIGIT2),temp3
	ori temp2,(ASCII_PUNKT)	; Punkt	
	STS(adr_DIGIT1),temp2
	STS(adr_DIGIT0),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
