; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Timer 0+1+2 berlauf-Int aktivieren (Timer/Counter Interrupt Mask)			
;																				
TIMER_AKTIVIEREN:
	ldi temp,(0<<OCIE2)|(0<<TOIE2)|(0<<TICIE1)|(0<<OCIE1A)|(0<<OCIE1B)|(0<<TOIE1)|(1<<TOIE0)
	out TIMSK,temp       
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; TIMER0 (8Bit) Vorteiler														
;																				
; CS02 CS01 CS00 	Description													
;	0 	0 	0 		No clock source (Timer/Counter stopped).					
;	0 	0 	1 		clkI/O/		(No prescaling)									
;	0 	1 	0 		clkI/O/8 	(From prescaler)								
; *	0 	1 	1 		clkI/O/64 	(From prescaler)								
; 	1 	0 	0 		clkI/O/256 	(From prescaler)								
; 	1 	0 	1 		clkI/O/1024 (From prescaler)								
;	1 	1 	0 		External clock source on T0 pin. Clock on falling edge.		
;	1 	1 	1 		External clock source on T0 pin. Clock on rising edge.		
TIMER0_INITIALISIERUNG_ms:
.equ TIMERWERT0	=256-100		; 50;(2 hoch 8  minus...)	
	ldi temp,(0<<CS02)|(1<<CS01)|(1<<CS00)
	OUT TCCR0,temp

	ldi temp, TIMERWERT0	; TIMER0 Startwert		
	mov TIMER0,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Datenblatt Seite 97															
;	 CS12 CS11 CS10 Description													
;		0	0 	0 	No clock source. (Timer/Counter stopped)					
;		0	0 	1 	clkI/O/1 (No prescaling)									
;		0	1 	0 	clkI/O/8 (From prescaler)									
;		0	1 	1 	clkI/O/64 (From prescaler)									
;		1	0 	0 	clkI/O/256 (From prescaler)									
;		1	0 	1 	clkI/O/1024 (From prescaler)								
;		1	1 	0 	External clock source on T1 pin. Clock on falling edge.		
;		1	1 	1 	External clock source on T1 pin. Clock on rising edge.      
TIMER1_INITIALISIERUNG_PWM:
;	ldi     temp,(1<<COM1A0)|(1<<COM1A1)|(1<<COM1B0)|(1<<COM1B1)|(0<<WGM11)|(1<<WGM10); 8Bit  invertiert		
	ldi     temp,(0<<COM1A0)|(0<<COM1A1)|(0<<COM1B0)|(1<<COM1B1)|(0<<WGM11)|(1<<WGM10); 8Bit  nicht invertiert
	out     TCCR1A,temp              

	ldi     temp,(1<<WGM12)|(0<<CS12)|(0<<CS11)|(1<<CS10)	;VT:1	PWM 62.500	31.250	15.625 Hz
	out     TCCR1B,temp   

.equ START=(255/2)		; 8Bit

	ldi temp1, low(START)
	ldi temp2,high(START)
	out OCR1AH,temp2	; zuerst H
	out OCR1AL,temp1	; dann   L

	ldi temp1, low(START)
	ldi temp2,high(START)
	out OCR1BH,temp2	; zuerst H
	out OCR1BL,temp1	; dann   L


;	sbi DDRB,1 		; auf Ausgang	
;   sbi DDRB,2 		; auf Ausgang	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIM0_OVF:
	mov KOPIE_TEMP, TEMP; Sichern von TEMP						
	in	KOPIE_SREG,SREG ; Sichern des SREG 						
;-------------------------------------------------------------------------------
	out TCNT0,TIMER0
	inc COUNTER			; +1				
;-------------------------------------------------------------------------------
TIM0_RUN:
	in temp,PINC		; PIN abfragen		
	com temp
	andi temp,0b00110000
;-------------------------------------------------------------------------------
	tst temp
	breq TIM0_START
	STS(adr_TASTE),temp
;-------------------------------------------------------------------------------
TIM0_START:
	BALKEN_OFF
	mov temp,COUNTER
	cpi temp,0
	breq TIM0_D0
	cpi temp,1
	breq TIM0_D1
	cpi temp,2
	breq TIM0_D2
	cpi temp,3
	breq TIM0_D3
	clr COUNTER
	rjmp TIM0_RUN
;-------------------------------------------------------------------------------
TIM0_D0:
	A0_ON
	LDS temp,(adr_DIGIT0)
	rjmp BALKEN_TEMP
;-------------------------------------------------------------------------------
TIM0_D1:
	A1_ON
	LDS temp,(adr_DIGIT1)
	rjmp BALKEN_TEMP
;-------------------------------------------------------------------------------
TIM0_D2:
	A2_ON
	LDS temp,(adr_DIGIT2)
	rjmp BALKEN_TEMP
;-------------------------------------------------------------------------------
TIM0_D3:
	A3_ON
	LDS temp,(adr_DIGIT3)
	rjmp BALKEN_TEMP
;-------------------------------------------------------------------------------
TIM0_FERTIG:
	out	SREG,KOPIE_SREG	; Wiederherstellen von SREG				
	mov TEMP, KOPIE_TEMP; Wiederherstellen von TEMP				
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
BALKEN_TEMP:
	sbrc temp,0
	a_ON
	sbrc temp,1
	b_ON
	sbrc temp,2
	c_ON
	sbrc temp,3
	d_ON
	sbrc temp,4
	e_ON
	sbrc temp,5
	f_ON
	sbrc temp,6
	g_ON
	sbrc temp,7
	DP_ON
rjmp TIM0_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################


