; Wattmeter DC Leistungsmesser					
; fr ATmega8									
; Bernhard.Erfurt@gmx.de						
; 03/2024										
;												


; ATmega8 										
.include "m8def.inc"
.include "MACRO.asm"
; KONSTANTEN									
.equ FAKTOR_U=282
.equ FAKTOR_i=259
; ZEICHEN-DARSTELLUNG - 7-SEGMENT				
.equ ASCII_0					=0b00111111	; 0 
.equ ASCII_1					=0b00000110	; 1 
.equ ASCII_2					=0b01011011	; 2 
.equ ASCII_3					=0b01001111	; 3 
.equ ASCII_4					=0b01100110	; 4 
.equ ASCII_5					=0b01101101	; 5 
.equ ASCII_6					=0b01111101	; 6 
.equ ASCII_7					=0b00000111	; 7 
.equ ASCII_8					=0b01111111	; 8 
.equ ASCII_9					=0b01101111	; 9 

.equ ASCII_AUS					=0b00000000	; ''
.equ ASCII_PUNKT				=0b10000000	; . 
.equ ASCII_VOLL					=0b11111111	; 8.
.equ ASCII_MINUS				=0b01000000	; - 
.equ ASCII_GRAD					=0b01100011	;  
.equ ASCII_V					=0b00111110	; V 

.equ ASCII_A					=0b01110111	; A 
.equ ASCII_B					=0b01111100	; B 
.equ ASCII_C					=0b01011000	; C 
.equ ASCII_D					=0b01011110	; D 
.equ ASCII_E					=0b01111001	; E 
.equ ASCII_F					=0b01110001	; F 
.equ ASCII_P					=0b01110011	; P 
; BEEP											
.equ BEEP_PIN_NR					= 2
.equ BEEP_DDR						= DDRC
.equ BEEP_PORT						= PORTC
; PWM											
.equ PWM_PIN_NR						= 2
.equ PWM_DDR						= DDRB
; 7Segment-DIGIT								
.equ A0_PIN_NR						= 7		; rechtes Digit	
.equ A0_DDR							= DDRD
.equ A0_PORT						= PORTD

.equ A1_PIN_NR						= 4
.equ A1_DDR							= DDRD
.equ A1_PORT						= PORTD

.equ A2_PIN_NR						= 3
.equ A2_DDR							= DDRD
.equ A2_PORT						= PORTD

.equ A3_PIN_NR						= 0
.equ A3_DDR							= DDRD
.equ A3_PORT						= PORTD

; 7Segment-BALKEN								
.equ a_PIN_NR						= 1
.equ a_DDR							= DDRD
.equ a_PORT							= PORTD
.equ b_PIN_NR						= 1
.equ b_DDR							= DDRB
.equ b_PORT							= PORTB
.equ c_PIN_NR						= 5
.equ c_DDR							= DDRD
.equ c_PORT							= PORTD
.equ d_PIN_NR						= 6
.equ d_DDR							= DDRB
.equ d_PORT							= PORTB
.equ e_PIN_NR						= 0
.equ e_DDR							= DDRB
.equ e_PORT							= PORTB
.equ f_PIN_NR						= 2
.equ f_DDR							= DDRD
.equ f_PORT							= PORTD
.equ g_PIN_NR						= 6
.equ g_DDR							= DDRD
.equ g_PORT							= PORTD
.equ DP_PIN_NR						= 7
.equ DP_DDR							= DDRB
.equ DP_PORT						= PORTB
; TASTE											
.equ TASTE_A_PIN_NR					= 4
.equ TASTE_A_DDR					= DDRC
.equ TASTE_A_PORT					= PORTC
.equ TASTE_B_PIN_NR					= 5
.equ TASTE_B_DDR					= DDRC
.equ TASTE_B_PORT					= PORTC
; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						=SRAM_START		; 0x0060 START Adresse 		


.equ adr_DIGIT0						=SRAM_START+10	; rechts					
.equ adr_DIGIT1						=SRAM_START+11	
.equ adr_DIGIT2						=SRAM_START+12	
.equ adr_DIGIT3						=SRAM_START+13	

.equ adr_MENUE						=SRAM_START+100
.equ adr_TASTE						=SRAM_START+101

.equ adr_U							=SRAM_START+110
.equ adr_i							=SRAM_START+111
.equ adr_P_L						=SRAM_START+112
.equ adr_P_H						=SRAM_START+113

.equ adr_ADC_U_L					=SRAM_START+150
.equ adr_ADC_U_H					=SRAM_START+151
.equ adr_ADC_i_L					=SRAM_START+152
.equ adr_ADC_i_H					=SRAM_START+153


.equ adr_SRAM_CHECK					=SRAM_START+943	; SRAM CHECK muss immer "S" sein	

; REGISTER										
.def KOPIE_SREG = R9
.def KOPIE_TEMP = R10

.def COUNTER	= R11
.def TIMER0		= R12
.def NULL 		= R13
.def EINS 		= R14
.def VOLL		= R15
.def temp 		= R16
.def temp1 		= R17
.def temp2 		= R18
.def temp3 		= R19
.def temp4 		= R20
.def temp5 		= R21
.def temp6 		= R22
.def temp7 		= R23
.def temp8 		= R24
.def temp9 		= R25

.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   ; Timer1 Overflow Handler           	
rjmp TIM0_OVF   		; Timer0 Overflow Handler           					
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	
;-------------------------------------------------------------------------------
; Unkorrekten Interrupt Aufruf 													
INTERRUPT_ERROR:
	rcall wait_100ms
	rcall wait_100ms
	rjmp INTERRUPT_ERROR
;-------------------------------------------------------------------------------
RESET:                        
	ldi temp, LOW(RAMEND)					; STACK initialisieren								
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
	rcall WDR_INITIALISIERUNG				; WDR_INITIALISIERUNG								
	rcall SRAM_CLEAR						; SRAM lschen										
	rcall STARTWERTE						; Startwerte										
	rcall PORT_INITIALISIERUNG				; PORT_CLEAR										
	rcall ADC_INITIALISIERUNG				; ADC_INITIALISIERUNG								
	rcall TIMER0_INITIALISIERUNG_ms			; TIMER-LED-TASTEN									
	rcall TIMER1_INITIALISIERUNG_PWM		; TIMER-PWM											
	rcall TIMER_AKTIVIEREN					; TIMER												
	rcall PROGRAMM_CHECK					; CHECK												
;rcall PROGRAMM_STOP
	rcall WAIT_1s
	rcall BEEP_KURZ
	sei										; Interrupts freigeben								
;-------------------------------------------------------------------------------
; alles on																		
	STS(adr_DIGIT0),VOLL					
	STS(adr_DIGIT1),VOLL
	STS(adr_DIGIT2),VOLL
	STS(adr_DIGIT3),VOLL
	rcall WAIT_1s
;-------------------------------------------------------------------------------
; Begrung																		
	ldi temp4,(ASCII_2)
	ldi temp3,(ASCII_0)
	ldi temp2,(ASCII_2)
	ldi temp1,(ASCII_4)
	STS(adr_DIGIT0),temp1
	STS(adr_DIGIT1),temp2
	STS(adr_DIGIT2),temp3
	STS(adr_DIGIT3),temp4
	rcall WAIT_1s
; alles off																		
	STS(adr_DIGIT0),NULL
	STS(adr_DIGIT1),NULL
	STS(adr_DIGIT2),NULL
	STS(adr_DIGIT3),NULL
	rcall BEEP_KURZ
	rcall WAIT_100ms
	rcall BEEP_KURZ
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR										; Watch-Dog-RESET	
	rcall ADC_U
	rcall ADC_i
	rcall BERECHNUNG_P
	rcall MENUE
	rcall PROGRAMM_CHECK					; CHECK				
	rcall TASTEN_WAIT
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
BERECHNUNG_P:
	LDS temp1,(adr_U)
	LDS temp2,(adr_i)
	mul temp1,temp2
	mov temp1,R0
	mov temp2,R1
	rcall DIVISION_16_100 ; durch 100
	STS(adr_P_L),temp1
	STS(adr_P_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "ADC.asm"
.include "TIMER.asm"
.include "LED.asm"
;.include "EEPROM.asm"
.include "SONSTIGES.asm"
.include "MENUE.asm"
.include "WAIT.asm"
.include "ZAHLEN.asm"

